import request from '@/utils/request'

export function fetchGambleMemberList(query) {
  return request({
    url: '/gambleMembers',
    method: 'get',
    params: {
      limit: query.limit,
      offset: (query.page - 1) * query.limit,
      name: query.name,
      chipsSort: query.chipsSort,
      updatedSort: query.updatedSort
    }
  })
}

export function fetchWeChatMemberList(data, query) {
  // TODO check data 帶什麼
  return request({
    url: `/weChatRooms/${data.room}/weChatUsers`,
    method: 'get',
    params: {
      limit: query.limit,
      offset: (query.page - 1) * query.limit,
      name: query.name,
      chipsSort: query.chipsSort,
      updatedSort: query.updatedSort
    }
  })
}

export function chipsDeposit(data) {
  return request({
    url: `/gambleMembers/${data.WeChatUser.GambleMember.id}/deposit`,
    method: 'put',
    data: {
      chips: data.depositChips
    }
  })
}

export function chipsReward(data) {
  return request({
    url: `/gambleMembers/${data.WeChatUser.GambleMember.id}/reward`,
    method: 'put',
    data: {
      chips: data.rewardChips
    }
  })
}

export function createGambleMember(data) {
  return request({
    url: '/gambleMembers',
    method: 'post',
    data: {
      name: data.name,
      chips: data.chips
    }
  })
}

export function fetchGameHistory(data, query) {
  return request({
    url: `/gambleMembers/${data.id}/history`,
    method: 'get',
    params: {
      limit: query.limit,
      offset: (query.page - 1) * query.limit,
      startAt: query.startAt,
      endAt: query.endAt
    }
  })
}

export function fetchChipsHistory(data, query) {
  return request({
    url: `/gambleMembers/${data.id}/chipsLogs`,
    method: 'get',
    params: {
      limit: query.limit,
      offset: (query.page - 1) * query.limit,
      startAt: query.startAt,
      endAt: query.endAt
    }
  })
}

export function fetchPersonGameDetail(gambleMemberId, gambleGameBucketId) {
  return request({
    url: `/gambleMembers/${gambleMemberId}/gambleGameBuckets/${gambleGameBucketId}/detail`,
    method: 'get'
  })
}

export function fetchAgentList(name) {
  return request({
    url: '/agents',
    method: 'get',
    params: {
      limit: 20,
      offset: 0,
      name
    }
  })
}

export function updateBelongAgent(member, agent) {
  return request({
    url: `/gambleMembers/${member.id}/belong_agent`,
    method: 'put',
    data: {
      agent: agent.id
    }
  })
}
